//
//Chameleon USB SPA3A API Ver1.00 By OPTIMIZE
//

#include "stdafx.h"
#include "cusb2.h"

#pragma warning(disable:4996)

cusb2::cusb2()
{
	USBDevice = new CCyUSBDevice(NULL);
}

cusb2::~cusb2()
{
	if(USBDevice->IsOpen()) USBDevice->Close();
	delete USBDevice;
}

bool cusb2::fwload(u64 *device_dna, u8 *fw)
{
	u8 d;
	bool find = false;
	bool fwload = false;
	wchar_t wcs[64];
	size_t n;


	for(d=0; d < USBDevice->DeviceCount(); d++)
	{
		USBDevice->Reset();
		USBDevice->Manufacturer[0]=0;	//OopenfoCX̏񂪎ĉŏĂ
		if(USBDevice->Open(d)){
			if(((USBDevice->BcdDevice & 0x0f00) == 0x0000))	//FX2LP:0xA0nn FX2:0x00nn
			{
					if((USBDevice->VendorID == 0x04B4) && (USBDevice->ProductID == 0x8613)) find = true;	//FW[h
					if((USBDevice->VendorID == 0x04B4) && (USBDevice->ProductID == 0x1004)) find = true;	//FW[h
			}
			if(find){
				//Kvȃt@[[hĂ邩Ŕf
				mbstowcs_s(&n, wcs, 64, (char *)"FX2_SPA3", 64);
				if(wcscmp(USBDevice->Manufacturer, wcs) != 0)
				{
					fwload = true;
					//IICC[W̃[h8051Zbg
					u16 len, ofs;
					long llen;

					//8051~
					USBDevice->ControlEndPt->ReqCode = 0xA0;
					USBDevice->ControlEndPt->Value = 0xE600;
					USBDevice->ControlEndPt->Index = 0;
					llen = 1;
					u8 tmp = 1;
					USBDevice->ControlEndPt->Write(&tmp, llen);	

					fw += 8;
					for(;;){
						len = fw[0]*0x100 + fw[1];
						ofs = fw[2]*0x100 + fw[3];	

						//x_NGXg'A0'gp8051ɏ
						USBDevice->ControlEndPt->Value = ofs;
						llen = len & 0x7fff;
						USBDevice->ControlEndPt->Write(fw+4, llen);	

						if(len & 0x8000)
							break;	//ŏIiZbgj
						fw += len+4;
					}
				}
				find = false;
			}
			USBDevice->Close();
			if(fwload) break;
		}
	}
	if(USBDevice->DeviceCount() == 0) return false;


	//ċÑt@[ɐڑ
	find = false;
	u32 i;
	u64 ser;
	wchar_t *s, t;
	for(i = 0; i < 40; i++){
		Sleep(100);
		for(d=0; d < USBDevice->DeviceCount(); d++){
			if(USBDevice->Open(d)){
				if((USBDevice->VendorID == 0x04B4) && (USBDevice->ProductID == 0x1004)){
					//foCXSerialNumber񂩂device_dna擾
					ser = wcstoul(USBDevice->SerialNumber+8, &s, 16);
					t = USBDevice->SerialNumber[8];
					USBDevice->SerialNumber[8] = 0;
					ser = ser + ((u64)wcstoul(USBDevice->SerialNumber, &s, 16)<<32);
					USBDevice->SerialNumber[8] = t;
					if(*device_dna == 0){
						if(ser != 0){
							*device_dna = ser;
							find = true;
							break;
						}
					}
					else if(*device_dna == ser){
						find = true;
						break;
					}
				}
				USBDevice->Close();
			}
		}
		if(find) break;
	}
	if(!find){
		return false;
	}
	return true;
}

CCyUSBEndPoint* cusb2::get_endpoint(u8 addr)
{
	u8 ep;
	for(ep = 0; ep < USBDevice->EndPointCount(); ep++)
	{
		if(USBDevice->EndPoints[ep]->Address == addr)
		{
			USBDevice->EndPoints[ep]->Reset();
			return USBDevice->EndPoints[ep];
		}
	}
	return NULL;
}

bool cusb2::xfer(CCyUSBEndPoint *ep, PUCHAR buf, LONG &len)
{
	if(ep->GetXferSize() < (unsigned)len)
		ep->SetXferSize(len);
	return(ep->XferData(buf, len));
}

void thread_proc(cusb2_tcb *tcb)
{
	u32 i;
	u32 qnum=0;
	bool success = false;
	LONG len;
	CCyUSBEndPoint *ep;


	ep = tcb->ep;
	tcb->nsuccess = 0;
	tcb->nfailure = 0;
	tcb->looping = true;

	OVERLAPPED *ovlp = new OVERLAPPED[tcb->ques];
	PUCHAR *data = new PUCHAR[tcb->ques];
	PUCHAR *context = new PUCHAR[tcb->ques];
	ep->SetXferSize(tcb->xfer);
	BOOL ret=SetThreadPriority(tcb->th, THREAD_PRIORITY_HIGHEST);

	if(tcb->epaddr & 0x80)
	{	//IN(FX2->PC)]
		for(i=0; i<tcb->ques; i++)
		{
			data[i] = new UCHAR[tcb->xfer];
			ovlp[i].hEvent = CreateEvent(NULL, false, false, NULL);
			context[i] = ep->BeginDataXfer(data[i], tcb->xfer, &(ovlp[i]));
			qnum++;
		}
		for(i=0;;)
		{
			if(!ep->WaitForXfer(&(ovlp[i]),500))
			{
				ep->Abort();
				WaitForSingleObject(&(ovlp[i]),500);
			}

			len = tcb->xfer;
			success = ep->FinishDataXfer(data[i], len, &(ovlp[i]), context[i]);
			qnum--;

			if(success)
			{
				if(tcb->looping)
				{
					if(!tcb->cb_func(data[i], (u32)len))
					{
						tcb->looping = false;
					}
				}
				tcb->nsuccess++;
			}
			else
			{
				tcb->nfailure++;
			}

			if(tcb->looping)
			{
				context[i] = ep->BeginDataXfer(data[i], tcb->xfer, &(ovlp[i]));
				qnum++;
			}

			if(++i == tcb->ques) i = 0;
			if(tcb->looping == false)
			{
				if(qnum == 0)
					break;
			}
		}
	}
	else
	{	//OUT(PC->FX2)]
		for(i=0; i<tcb->ques; i++)
		{
			data[i] = new UCHAR[tcb->xfer];
			ovlp[i].hEvent = CreateEvent(NULL, false, false, NULL);
			if(tcb->looping)
			{
				if(!tcb->cb_func(data[i], (u32)tcb->xfer))
				{
					tcb->looping = false;
				}
			}
			context[i] = ep->BeginDataXfer(data[i], tcb->xfer, &(ovlp[i]));
			qnum++;
		}
		for(i=0;;)
		{
			if(!ep->WaitForXfer(&(ovlp[i]),500))
			{
				ep->Abort();
				WaitForSingleObject(&(ovlp[i]),500);
			}

			len = tcb->xfer;
			success = ep->FinishDataXfer(data[i], len, &(ovlp[i]), context[i]);
			qnum--;

			if(success)
			{
				tcb->nsuccess++;
			}
			else
			{
				tcb->nfailure++;
			}

			if(tcb->looping)
			{
				if(!tcb->cb_func(data[i], (u32)tcb->xfer))
				{
					tcb->looping = false;
				}
				context[i] = ep->BeginDataXfer(data[i], tcb->xfer, &(ovlp[i]));
				qnum++;
			}

			if(++i == tcb->ques) i = 0;
			if(tcb->looping == false)
			{
				if(qnum == 0)
					break;
			}
		}
	}

	for(i=0; i<tcb->ques; i++)
	{
		CloseHandle(ovlp[i].hEvent);
		delete [] data[i];
	}
	delete [] context;
	delete [] data;
	delete [] ovlp;
}

cusb2_tcb* cusb2::start_thread(u8 epaddr, u32 xfer, s32 ques, bool (*cb_func)(u8 *, u32))
{
	cusb2_tcb *tcb = new cusb2_tcb;
	tcb->epaddr = epaddr;
	tcb->ep = get_endpoint(epaddr);
	tcb->epaddr = epaddr;
	tcb->xfer = xfer;
	tcb->ques = ques;
	tcb->cb_func = cb_func;
	tcb->th = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)thread_proc, tcb, 0, NULL);
	Sleep(100);
	return tcb;
}

void cusb2::delete_thread(cusb2_tcb *tcb)
{
	WaitForSingleObject(tcb->th, INFINITE);
	delete tcb;
}
