// spd_chk.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "cusb2.h"
#include "spa3.h"


//#define DEBUG_SPA3
//#define WAIT_DISP


#ifdef DEBUG_SPA3
u8 spa3_bit[1024*64];
#else
u8 spa3_bit[]=
#include "spa3_bit.inc"
#endif

#define	MODE_IDLE	0
#define	MODE_START	1

#define DIR_FX2PC	0	//EP6IN (FX2 -> PC) transfer
#define DIR_PC2FX	1	//EP2OUT(PC -> FX2) transfer

#define BUF_LEN	1024*64
#define	QUE_NUM	16

#define START_SEED32	0x12345678

class cusb2 *usb;
class spa3 *spa3;

cusb2_tcb *tcb1;

s32 max_cnt;
s32 cnt;
s32 err_cnt;

#define PORT_BITS	35	//PC<->FPGAԂ̃|[grbgi͂Əo͓͂rbgj	

struct{//o(PC -> FPGA)|[g
	u64	init_val	:32;
	u64	DIR			: 1;
	u64	MODE		: 1;
	u64 RST			: 1;
} out_port;

struct{//(FPGA -> PC)|[g
	u64	wait_cnt	:31;
	u64	cmp_err		: 1;
} in_port;


bool fx2pc_func(u8 *buf, u32 len){
	static u32 cnt32=START_SEED32;
	u32 i,*p;
	p = (u32 *)buf;
	for(i=0; i < (len/4); i++)
	{
		if(p[i] != cnt32++)
		{
			if(err_cnt < 5) 
				printf("\nerr in %8.8X  %8.8X != %8.8X\n", cnt*BUF_LEN+i*4, p[i], cnt32-1);
			err_cnt++;
		}
	}
	if(cnt++ < max_cnt) return true;

	spa3->ep6in_stop();

	out_port.MODE = MODE_IDLE;
	spa3->port(PORT_BITS, (u8 *)&out_port, (u8 *)&in_port);
	return false;
}

bool pc2fx_func(u8 *buf, u32 len){
	static u32 cnt32=START_SEED32;
	u32 i,*p;
	p = (u32 *)buf;
	for(i=0; i < (len/4); i++)
	{
		p[i] = cnt32++;
	}
	if(cnt++ < max_cnt+QUE_NUM) return true;

	spa3->ep2out_stop();

	out_port.MODE = MODE_IDLE;
	spa3->port(PORT_BITS, (u8 *)&out_port, (u8 *)&in_port);
	return false;
}

void wait_and_showinfo(){
	usb->delete_thread(tcb1);
	if(err_cnt != 0)
	{
		printf(" NG(err=%d).\n", err_cnt);
	}
	else
	{
		printf(" OK.\n");
	}
//	printf("%fMbps\n",48.0*16.0* (BUF_LEN*max_cnt/2)/(BUF_LEN*max_cnt/2+(in_port.wait_cnt & 0x7fffffff)));	//48MHz 16bit
	printf("%fMbps\n",30.0*16.0* (BUF_LEN*max_cnt/2)/(BUF_LEN*max_cnt/2+(in_port.wait_cnt & 0x7fffffff)));	//30MHz 16bit
	if(in_port.cmp_err) 
		printf("FX2 compare err!!\n");
}

void disp_wait(u16 *buf){
	s32 i;
	u32 max = 0;
	u32 max2 = 0;
	u32 ave = 0;

	for(i = 0; i < 1024; i++){
		printf("%4.4X ", buf[i]);
		if(i%8 == 7) printf("\n");
		if(buf[i] > max){
			max2 = max;		//ől͋NOɑ҂ꂽɂȂ̂ŁA2Ԗڂgp
			max = buf[i];
		}
		ave += buf[i];
	}
	printf("wait cycle(48MHz) ave = %d max = %d.\n", ave/1024, max2);
}


int _tmain(int argc, _TCHAR* argv[])
{
	u64 dev_dna;
#ifdef WAIT_DISP
	u16 wait16[1024];
#endif

#ifdef DEBUG_SPA3
	FILE *fp_spa3;
	fopen_s(&fp_spa3, "spa3a\\spd_chk.bit","rb");
	fread(spa3_bit, 1, sizeof(spa3_bit), fp_spa3);
	fclose(fp_spa3);
#endif

	usb = new cusb2();
	spa3 = new class spa3();
	u8 t = 0;
	if(argc == 2)
	{
		char *s;
		t = (u8)strtol(argv[1], &s, 10);
	}
	dev_dna = 0;
	if(spa3->init(usb, &dev_dna, spa3_bit))	//Spartan3ARtBO[V
	{
		printf("Device DNA = %8.8X%8.8X\n", (u32)(dev_dna >> 32), (u32)dev_dna);

		spa3->set_fifo_16();	//FIFO 16bit
		//spa3->ifconfig(0xE3);				//slave FIFO, IFCLK=48MHz, IFCLKo,  (Sync)[h
		spa3->ifconfig(0xA3);				//slave FIFO, IFCLK=30MHz, IFCLKo,  (Sync)[h

		out_port.init_val = START_SEED32;
		out_port.DIR = 0;
		out_port.MODE = MODE_IDLE;
		out_port.RST = 1;
		spa3->port(PORT_BITS, (u8 *)&out_port, (u8 *)&in_port);

		//SPA3AZbgip[^[hj
		out_port.RST = 0;
		spa3->port(PORT_BITS, (u8 *)&out_port, (u8 *)&in_port);

		cnt=err_cnt=0;
		max_cnt=1024;
		tcb1 = usb->start_thread(0x86, BUF_LEN, QUE_NUM, fx2pc_func);

		spa3->ep6in_start();

		out_port.DIR = DIR_FX2PC;
		out_port.MODE = MODE_START;
		spa3->port(PORT_BITS, (u8 *)&out_port, (u8 *)&in_port);

		printf("Spa3->PC(EP6IN) ](%dMbyte)",BUF_LEN*max_cnt/(1024*1024));
		wait_and_showinfo();
#ifdef WAIT_DISP
		spa3->mem_read(0, 1024, wait16);
		disp_wait(wait16);
		memset(wait16, 0, sizeof(wait16));
		spa3->mem_write(0, 1024, wait16);
#endif


		out_port.RST = 1;
		spa3->port(PORT_BITS, (u8 *)&out_port, (u8 *)&in_port);

		//SPA3AZbgip[^[hj
		out_port.RST = 0;
		spa3->port(PORT_BITS, (u8 *)&out_port, (u8 *)&in_port);

		cnt=err_cnt=0;
		max_cnt=1024;
		tcb1 = usb->start_thread(0x02, BUF_LEN, QUE_NUM, pc2fx_func);

		spa3->ep2out_start();

		out_port.DIR = DIR_PC2FX;
		out_port.MODE = MODE_START;
		spa3->port(PORT_BITS, (u8 *)&out_port, (u8 *)&in_port);

		printf("PC->Spa3(EP2OUT) ](%dMbyte)",BUF_LEN*max_cnt/(1024*1024));
		wait_and_showinfo();
#ifdef WAIT_DISP
		spa3->mem_read(0, 1024, wait16);
		disp_wait(wait16);
#endif
	}
	delete usb;
	return 0;
}
